*
* file = hlitebar.prg
* Horizontal lite bar screen generator for dbase III
* ADAPTED from "Dbase III Plus programming techniques", page 88
* (c) 1986 Cary N. Prague
* Except this version is expanded & "improved" - a relative notion at best
*
* G.L. Peterson - If you can take this little bit of work and found a
* financial empire on it, more power to you. Any money you make with it
* belongs to you. I s'pose Cary may feel differently....
*
* If you wish to nest these menus, globally change the parameter M'N' where
* 'N' corresponds to the individual menu number. This will insure all variables
* are unique from menu to menu.
*


CLEAR
SET TALK OFF
SET ECHO OFF
SET ESCAPE OFF

* THIS IS THE CONFIGURATION DATA FOR THE MENU SYSTEM
******************************************************************************

* SET THE MENU TITLE(S) HERE
STORE "ABC CORPORATION CUSTOMER CREDIT SYSTEM" TO M1TITLE1
STORE "--------------------------------------" TO M1TITLE2

* SET THE MENU FOOTERS (OPERATOR INSTRUCTIONS, ETC. HERE)
STORE "USE ARROW KEYS TO MOVE HIGHLIGHT AND 'ENTER' TO SELECT ITEM" TO M1FOOT1
STORE "OR SELECT INPUT BY MENU NUMBER, OR OPTION 1ST LETTER" TO M1FOOT2

* SET TO THE MAX NUMBER OF MENU ITEMS
M1MNUMAX = 6

* SET THE SCREEN COLUMN LOCATIONS TO START THE MENU ITEMS AT
* (A PREPOSITION IS A WORD YOU SHOULD NEVER END A SENTENCE WITH)
STORE '02' + '11' + '24' + '37' + '48' + '60' TO M1LOCS

* SET UP THE LINE OF OPTIONS AT THE PROPER COLUMN LOCATIONS
STORE ' Add      Change       Delete       View       Print       Exit' ;
  TO M1MNULN

* SET TO THE INDIVIDUAL LENGTHS OF THE MENU ITEMS ABOVE
STORE '03' + '06' + '06' + '04' + '05' + '04' TO M1LENS


* SET THE MENU ITEM TITLES TO DISPLAY
STORE "1. Add a new customer record."                TO M1MSG1
STORE "2. Change an existing customer record. "      TO M1MSG2
STORE "3. Delete a customer record from the system." TO M1MSG3
STORE "4. View a customer record."                   TO M1MSG4
STORE "5. Print a customer record."                  TO M1MSG5
STORE "6. Exit from the customer credit system."     TO M1MSG6

* SET THE 1ST LETTER OF EACH MENU OPTION FOR OPERATOR SELECTION
STORE "A"            TO M1LET1
STORE "C"            TO M1LET2
STORE "D"            TO M1LET3
STORE "V"            TO M1LET4
STORE "P"            TO M1LET5
STORE "E"            TO M1LET6

* SET THE ACTIONS TO TAKE FOR EACH MENU ITEM SELECTED
STORE "DO ADD"       TO M1ACT1
STORE "DO CHANGE"    TO M1ACT2
STORE "DO DELETE"    TO M1ACT3
STORE "DO VIEW"      TO M1ACT4
STORE "DO PRINT"     TO M1ACT5
STORE "M1MNUCK = .F." TO M1ACT6

* SET THE DEFAULT MENU ITEM YOU WANT HIGHLIGHTED INITIALLY HERE
M1SEL = 1

******************************************************************************


* PAINT THE SCREEN
CLEAR

* DRAW A PLEASING BOX FOR OPERATOR INPUTS
@  6, 1 TO  6, 78
@ 20, 1 TO 20, 78
@  1, 0 TO 23, 79 DOUBLE

* DISPLAY THE MENU TITLE(S)
@ 2, (80 - LEN(M1TITLE1))/2 SAY M1TITLE1
@ 3, (80 - LEN(M1TITLE2))/2 SAY M1TITLE2

* DISPLAY THE FOOTERS
@ 21, (80 - LEN(M1FOOT1))/2 SAY M1FOOT1
@ 22, (80 - LEN(M1FOOT2))/2 SAY M1FOOT2




* MAIN MENU LOOP: DISPLAY THE SCREEN & GET A RESPONSE
M1MNUCK = .T.
DO WHILE M1MNUCK

  * SHOW US OUR OPTIONS IN NORMAL (NON-HIGHLIGHTED) MODE
  @ 4, 9 SAY M1MNULN

  * FIND THE COLUMN AT WHICH MENU HIGHLIGHTING BEGINS 
  M1COL = VAL(SUBSTR(M1LOCS, M1SEL*2-1, 2)) + 8

  * GET THE MENU TEXT TO HIGHLIGHT
  M1HILITE = SUBSTR(M1MNULN, VAL(SUBSTR(M1LOCS, M1SEL*2-1, 2)), ;
                           VAL(SUBSTR(M1LENS, M1SEL*2-1, 2)) )

  * NOW HIGHLIGHT OUR OPTION & TURN HIGHLIGHTING MODE BACK OFF
  SET COLOR TO N/W+
  @ 4, M1COL SAY M1HILITE
  SET COLOR TO

  * SELECT THE PROMPT MESSAGE & PRINT IT, CENTERED, BELOW THE MENU
  STORE 'M1MSG' + STR(M1SEL, 1) TO M1MSGNUM
  @  5, 2 CLEAR TO 5, 78
  @  5, (80 - LEN(&M1MSGNUM))/2 SAY &M1MSGNUM

  * FETCH THE OPERATOR KEYBOARD INPUT
  M1OPIN = 0
  DO WHILE M1OPIN = 0
    M1OPIN = INKEY()
  ENDDO

  * HANDLE OPERATOR INPUT OF ARROW KEYS
  DO CASE

    * HOME KEY, SELECT THE 1ST OPTION
    CASE M1OPIN = 1
      M1SEL = 1

    * END KEY, GO TO THE LAST OPTION
    CASE M1OPIN = 6
      M1SEL = 6

    * RIGHT ARROW KEY, HIGHLITE THE NEXT OPTION (WITH ROLLOVER)
    CASE M1OPIN = 4
      IF M1SEL = M1MNUMAX
        M1SEL = 1
      ELSE
        M1SEL = M1SEL + 1
      ENDIF

    * LEFT ARROW KEY, HIGHLITE THE PREVIOUS OPTION (WITH ROLLOVER)
    CASE M1OPIN = 19
      IF M1SEL = 1
        M1SEL = M1MNUMAX
      ELSE
        M1SEL = M1SEL - 1
      ENDIF

    * HANDLE OPERATOR SELECTION OF HIGHLITED OPTION BY C/R INPUT
    CASE M1OPIN = 13
      M1MNUCK = .F.
      DO CASE
        CASE M1SEL = 1
          &M1ACT1

        CASE M1SEL = 2
          &M1ACT2

        CASE M1SEL = 3
          &M1ACT3

        CASE M1SEL = 4
          &M1ACT4

        CASE M1SEL = 5
          &M1ACT5

        CASE M1SEL = 6
          &M1ACT6

      ENDCASE

      * HANDLE OPERATOR SELECTION BY INPUTING 1ST LETTER OF THE COMMAND
      CASE UPPER (CHR(M1OPIN)) $ "&M1LET1&M1LET2&M1LET3&M1LET4&M1LET5&M1LET6"
        M1MNUCK = .F.
        DO CASE
          CASE UPPER(CHR(M1OPIN)) $ "&M1LET1"
            &M1ACT1

          CASE UPPER(CHR(M1OPIN)) $ "&M1LET2"
            &M1ACT2

          CASE UPPER(CHR(M1OPIN)) $ "&M1LET3"
            &M1ACT3

          CASE UPPER(CHR(M1OPIN)) $ "&M1LET4"
            &M1ACT4

          CASE UPPER(CHR(M1OPIN)) $ "&M1LET5"
            &M1ACT5

          CASE UPPER(CHR(M1OPIN)) $ "&M1LET6"
            &M1ACT6

        ENDCASE

 
      * HANDLE OPERATOR SELECTION BY INPUTING MENU ITEM NUMBER
      CASE CHR(M1OPIN) $ "123456"
        M1MNUCK = .F.
        DO CASE
          CASE CHR(M1OPIN) $ "1"
            &M1ACT1

          CASE CHR(M1OPIN) $ "2"
            &M1ACT2

          CASE CHR(M1OPIN) $ "3"
            &M1ACT3

          CASE CHR(M1OPIN) $ "4"
            &M1ACT4

          CASE CHR(M1OPIN) $ "5"
            &M1ACT5

          CASE CHR(M1OPIN) $ "6"
            &M1ACT6

        ENDCASE

      * HANDLE OPERATOR INPUT OF 'ESC' KEY - EXIT MENU
      CASE M1OPIN = 27
        M1MNUCK = .F.

      * UNKNOWN INPUT, COMPLAIN BY BEEPING BELL & LOOP
      OTHERWISE
        ? CHR(7)

    ENDCASE
  ENDDO M1MNUCK

CLEAR
RELEASE ALL LIKE M1*
RETURN

